#!/usr/bin/ruby -w

require 'pp'
require 'multi'
require 'smulti'

class Foo
  def initialize
    multi(:hiya, 0)       {|x| puts "Zero: #{x}" }
    multi(:hiya, Integer) {|x| puts "Int: #{x}" }
    multi(:hiya, String)  {|x| puts "Str: #{x}" }
    multi(:hiya, lambda {|x| x.size > 2 }) {|x| puts "GT2: #{x}"}
  end
end

f = Foo.new()
f.hiya(0)
f.hiya(5)
f.hiya("hello")
f.hiya([1, 2, 3])
begin
  f.hiya([1])
rescue
  puts $!
end

multi(:fac, 0)       { 1 }
multi(:fac, Integer) {|x| x * fac(x-1)}
puts fac(5)

multi(:reverse, []) { [] }
multi(:reverse, Array) {|list| [list.pop] + reverse(list) }

pp reverse([1,2,3])

multi(:baz, 3, Object) { puts 3 }
multi(:baz, Object, String) {|o, str| puts str }

baz(3, "three")
baz(2, "two")

multi(:retest, /^a(.*)/) {|x| x }
multi(:retest, String) { '' }

pp retest('foo')
pp retest('afoo')

smulti(:foo, 'a') { puts "a FOUND"     }
smulti(:foo, /./) {|s, rest| foo(rest) }
smulti(:foo, // ) { puts "a NOT FOUND" }
foo('a')
foo('')
foo('ab')
foo('ba')
foo('bb')
